/****  IMDEF.H

       Header file for IMDEF.H
       Built by A. Warnock, ST Systems Corp., NASA/GSFC 5/90
       This file contains only the various defined symbols for IMDISP
       and it's associated modules.

****/

/* * * *  External Function Prototypes * * * */


/* * * *  External Global Variables * * * */

/* * * *  External Global Symbols * * * */

#define ALLOC_DTA            26    /* MS-DOS Int 21h Service */
#define CONTROL_LEFT_ARROW  243    /* Extended ASCII code */
#define CONTROL_RIGHT_ARROW 244    /* Extended ASCII code */
#define CURSORSIZE            9    /* The size of the cursor box square */
#define DOWN_ARROW          208    /* Extended ASCII code */
#define DOWN_LEFT_ARROW     207    /* Extended ASCII code */
#define DOWN_RIGHT_ARROW    209    /* Extended ASCII code */
#define END                 207    /* Extended ASCII code */
#define ESCAPE               27    /* ASCII code */
#define FALSE                 0
#define FREE                  1    /* FREE block indicator        */
#define GET_CUR_DIR        0x47    /* MS-DOS Int 21h Service */
#define HELP                 63
#define HOME                199    /* Extended ASCII code */
#define INC                  32
#define ImBufMax          30720    /* Size of the buffer for each open file */
                                   /* the possible logical block sizes */
                                   /* Buffer must be integral number of times */
#define LEFT_ARROW          203    /* Extended ASCII code */
#define LabelBufferLen     8192    /* Amount of label read in to parse */
#define MAXBLOCK         0xffff    /* Maximum block size          */
#define MAXDISPNL           768    /* The maximum number of lines of all displays */
#define MAXDISPNS          1024    /* The maximum number of samples of all displays */
#define MAXFONTSTROKES     3000    /* The size of the text font array */
#define MAXNUMFILES         512
#define MINALLOC            128    /* Minimum MBSize value */
#define MINUSSTEP            45    /* ASCII code */
#define MaxNumImages          3    /* Maximum number of open images */
#define MaxOpenFiles         10    /* Maximum number of open files at one time */
#define NALLOC               16    /* Number of bytes per paragraph */
#define NCOMMANDS            35    /* Number of IMDISP commands */
#define PAGELEN       dispnl/20
#define PLUSSTEP             43    /* ASCII code */
#define P_DATA            0x3c9    /* VGA Palette Data port  */
#define P_READ            0x3c7    /* VGA Palette Read port  */
#define P_WRITE           0x3c8    /* VGA Palette Write port */
#define RETURN               13    /* ASCII code */
#define RIGHT_ARROW         205    /* Extended ASCII code */
#define SELECT_ITEM          13    /* ASCII code */
#define SEL_DRIVE            14    /* MS-DOS Int 21h Service */
#define SRCH_FIRST           78    /* MS-DOS Int 21h Service */
#define SRCH_NEXT            79    /* MS-DOS Int 21h Service */
#define TRUE                  1
#define UP_ARROW            200    /* Extended ASCII code */
#define UP_LEFT_ARROW       199    /* Extended ASCII code */
#define UP_RIGHT_ARROW      201    /* Extended ASCII code */
#define WHAT_DRIVE           25    /* MS-DOS Int 21h Service */
#define X_DIR                59    /* MS-DOS Int 21h Service */

#define DISPMAXNUM            3*dispnl/20
#define MAXALLOC   NALLOC * ( ( MAXBLOCK-HSIZE-SSIZE ) / NALLOC )
#define SSIZE      sizeof ( SUNIT  )   /* Size of SUNIT */

/* #define MSC60 */                /* Uncomment this if using MSC v6.0 */

/* * * *  External Global Functions * * * */

#define Round(x)  ( ((x) > 0.0) ? (int)((x)+0.5) : (int)((x)-0.5) )
#define READ_PALETTE(index,r,g,b){outp(P_READ,index);r=inp(P_DATA);g=inp(P_DATA);b=inp(P_DATA);}
#define SET_PALETTE(index,r,g,b) {outp(P_WRITE,index);outp(P_DATA,r);outp(P_DATA,g);outp(P_DATA,b);}
